// Set implementation
// Matt Perry (mjperry2@uiuc.edu)

#ifndef _ELEMENT_H
#define _ELEMENT_H

#include <string>

class Set;

using namespace std;

class Element {
public:
    enum Type {
	NONE = 0,
	NUMBER = 1,
	STRING = 2,
	SET = 3
    };
    Type type;
    double number;
    string str;
    Set* set;

    Element();
    Element(float n);
    Element(string s);
    Element(const Set& s);
    Element(const Element& e);

    ~Element();

    Element& operator=(const Element& e);
    bool operator==(const Element& e) const;
};

ostream& operator<<(ostream& os, const Element& e);

#endif // element.h
